unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, math, FPimage, FileUtil, Forms,
  Controls, Graphics, Dialogs, IntfGraphics, LCLType,
  BGRABitmap, BGRABitmapTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FBitmap, FCopyBitmap: TBGRABitmap;
    FFadeArray: Array of Array of Byte;
    Cnt: QWord;
    Runs: Integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  FBitmap := TBGRABitmap.Create('test.jpg');
  FCopyBitmap := TBGRABitmap.Create;
  Cnt := 0;
  Runs := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FCopyBitmap.Free;
  FBitmap.Free;
end;

procedure TForm1.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  Repaint;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  px, py: Integer;
  mp: TPoint;
  TempBitmap: TBGRABitmap;
  p: PBGRAPixel;
begin
  mp := Mouse.CursorPos;
  mp := ScreenToClient(mp);
  mp.x := mp.x - Length(FFadeArray) div 2;
  mp.y := mp.y - Length(FFadeArray) div 2;

  Cnt := Cnt - GetTickCount64;

  TempBitmap := TBGRABitmap.Create(FCopyBitmap);

  p := TempBitmap.Data;

  for py := TempBitmap.Height - 1 downto 0 do
    for px := 0 to TempBitmap.Width - 1 do begin
      inc(p);
      if (px >= mp.x) and (px <= mp.x + High(FFadeArray)) and
         (py >= mp.y) and (py <= mp.y + High(FFadeArray)) then
      begin
        p^.red   := Max(p^.red   - FFadeArray[px - mp.x, py - mp.y], 0);
        p^.green := Max(p^.green - FFadeArray[px - mp.x, py - mp.y], 0);
        p^.blue  := Max(p^.blue  - FFadeArray[px - mp.x, py - mp.y], 0);
      end;
    end;

  TempBitmap.InvalidateBitmap;
  TempBitmap.Draw(Canvas, 0, 0, true);
  TempBitmap.Free;

  Cnt := Cnt + GetTickCount64;
  Inc(Runs);

  Caption := IntToStr(Cnt div Runs);
end;

procedure TForm1.FormResize(Sender: TObject);
var
  x, y: Integer;
  aSize: Integer;
  i: Integer;
begin
  aSize := Min(ClientWidth, ClientHeight);
  SetLength(FFadeArray, aSize);
  for y := 0 to aSize - 1 do begin
    SetLength(FFadeArray[y], aSize);
    for x := 0 to aSize - 1 do begin
      i := Round((Sin(y / aSize * Pi) * Sin(x / aSize * Pi)) * 255);
      FFadeArray[y, x] := i;
    end;
  end;

  FCopyBitmap.SetSize(ClientWidth, ClientHeight);
  FCopyBitmap.StretchPutImage(ClientRect, FBitmap, dmSet, 255);
end;

end.

